#!/usr/local/bin/perl
my $basewifky='wifky.pl';

my $basedir=$basewifky; $basedir =~ s/\.\w+((\.\w+)*)$/.dat$1/;
my $farmversion='0.2';
my $original_script_name=$ENV{SCRIPT_NAME};
my $original_path_info=$ENV{PATH_INFO};

# use strict; use warnings;

eval {
    my $pagedir = __FILE__ ; $pagedir =~ s/\.\w+((\.\w+)*)$/.dat$1/;
    unless( chdir($pagedir) ){
        mkdir($pagedir,0755);
        chdir($pagedir) or die("can not access $pagedir.");
    }
    if( ($ENV{PATH_INFO} =~ m|^/(\w+)/| || $ENV{PATH_INFO} =~ m|^/(\w+)$| ) &&
        chdir("./$1") )
    {
        &user_mode();
    }else{
        &root_mode();
    }
    &flush();
};
if( $@ ){
    print "Content-Type: text/plain;\n\n$@";
}
exit(0);

sub neighbors_link{
    my ($session,$symbol,$user,$title,$sharp)
        = ($_[0], $_[1] , $_[2] , split(/(?=#[pf][0-9mt])/,$_[3]) );
    if( $title =~ /^#/ ){
        ($title,$sharp)=($session->{title},$title);
    }else{
        $title = &denc($title);
    }
    if( defined($user) && $user ne '' ){
        my $fn='../'.$user.'/'.&title2fname( $title );
        if( -f $fn ){
            local $::me="$original_script_name/$user/";
            return &anchor( $symbol , { p=>$title } , undef , $sharp);
        }
    }else{
        my $fn = '../../'.$basedir.'/'.&title2fname( $title );
        if( -f $fn ){
            local $::me="../../$basewifky";
            return &anchor( $symbol , { p=>$title } , undef , $sharp);
        }
    }
    qq(<blink>${symbol}?</blink>);
}

sub preprocess_neighborslink{
    my ($text,$session)=@_;
    ${$text} =~ s!\[\[([^\|\]]+)\|([^\|\]]+)\|(\w*)?\]\]!
        &neighbors_link($session,$1,$3,$2)!ge;
}

sub load_root_config{
    my $configfn = shift;
    $configfn =~ s/\.\w+((\.\w+)*)$/.dat$1\/index.cgi/;
    grep( (/^\#?([^\#\!\t ]+)\t(.*)$/ and $::config{$1}=&deyen($2),0)
        , split(/\n/,&read_file($configfn) ) );
}

sub create_new_user{
    my $newuser=$::form{newuser};
    if( $newuser !~ /^\w+$/ ){
        &putenc('<div>Invalid user name %s</div>',$newuser);
    }elsif( -d $newuser ){
        &putenc('<div>user %s already exists</div>',$newuser);
    }else{
        &load_root_config("../$basewifky");
        eval{
            &ninsho();
        };
        if( $@ ){
            &puts("<div>Administrator's Sign is wrong</div>");
        }else{
            mkdir($newuser,0755);
            &putenc('<div>New user <a href="%s/%s/">%s</a> created.</div>'
                     , $ENV{SCRIPT_NAME}
                     , $newuser
                     , $newuser );
        }
    }
    &putenc('<p><a href="%s">Return</a>.</p>',$original_script_name);
}

sub list_users{
    &puts('<ul>');
    opendir(DIR,".") or die("can not open directory");
    foreach my $dir (sort grep{/^\w+$/} readdir(DIR) ){
        &putenc('<li><a href="%s/%s/">%s<a></li>'
            , $ENV{SCRIPT_NAME} , $dir , $dir); 
    }
    closedir(DIR);
    &puts('</ul>');
    &putenc('<form action="%s" method="POST">',$ENV{SCRIPT_NAME} );
    &puts('<div><strong>New user:</strong>');
    &puts('<input type="text" name="newuser" value="">');
    &puts('<strong>Sign:</strong>');
    &puts('<input type="password" name="password" value="">');
    &puts('<input type="submit" value="Create"></div>');
    &puts('</form>');
}

sub root_mode{
    unless( -f "../$basewifky" ){
        die('can not load base wifky.pl script:'.$basewifky);
    }
    do "../$basewifky"; die($@) if $@;
    &puts("Content-Type: text/html;\n");
    &puts('<html><body>');
    &puts('<h1>wifky farm</h1>');

    &read_form();
    if( exists $::form{newuser} ){
        &create_new_user();
    }else{
        &list_users();
    }
    &puts('</body></html>');
}

sub user_mode{
    unless( -f "../../$basewifky" ){
        die('can not load base wifky.pl script:'.$basewifky);
    }
    do "../../$basewifky"; die($@) if $@;

    my (undef,$username,$left) = split(/\//,$ENV{PATH_INFO},3);

    $ENV{SCRIPT_NAME} .= "/$username/";
    $ENV{PATH_INFO}    = "/$left";
    $::me = $::postme = $ENV{SCRIPT_NAME};

    opendir(DIR,"../../$basedir") or die('can not load original work directory');
        my @plugins=sort readdir(DIR);
    closedir(DIR);

    &read_form();
    &directory();
    foreach my $pl ( grep(/\.plg$/,@plugins) ){
        do "../../$basedir/$pl" ; die($@) if $@;
    }
    &load_config;
    &init_globals;

    $::inline_syntax_plugin{'199_neighborslink'} = \&preprocess_neighborslink;
    $::preferences{'  wifkyFarm'} = [
        { desc =>"script-revision $farmversion" , type =>'rem' },
    ];

    foreach my $pl ( grep(/\.pl$/,@plugins) ){
        do "../../$basedir/$pl" ; die($@) if $@;
    }

    if( exists $::form{a} && exists $::action_plugin{$::form{a}} ){
        $::action_plugin{ $::form{a} }->();
    }elsif( exists $::form{p} ){ # page view
        if( exists $::form{f} ){ # output attachment
            &action_cat;
        }else{ # output page itself.
            &action_view($::form{p});
        }
    }elsif( &object_exists($::config{FrontPage}) ){
        &action_view($::config{FrontPage});
    }else{
        &do_index('recent','rindex','-l');
    }
}
